public class Populacao
{
	final static int POPSIZE = 100,			// No da populao
					 NOLINEAR3 = 3,			// f'=1/(5*(1-num)+1)-1/(5+1)
					 NOLINEAR  = 2,			// f'=f*(f-min+10)/10
					 WINDOW    = 1,			// f'=f-min+1
					 NORMAL    = 0;			// f'=f
	final double	 PPBOM = 100;			// percentagem para bom (max 100)
	final int        LLONG = 63;			// n bits dum long integer - 1
	Genes	[]pop = new Genes[POPSIZE];		// populao de genomas
	Genes	[]popaux = new Genes[POPSIZE];	// populao auxiliar
	long	generation;						// corrente gerao
	Genes	bestgenome;						// melhor genoma
	int		best;							// ndice melhor genoma
	double	tfitness;						// fitness total da populao
	boolean alterations;					// Flag de bestgenome
	double	min, max, med;					// Estatsticas
	double	pmut;							// percentagem de mutao
	int		nmut;							// No mutaes
	
	public Populacao(int ngenes) {
		int i;
		
		for (i=0; i<POPSIZE; i++)
				pop[i] = new Genes(ngenes);
		bestgenome = new Genes(ngenes);
		bestgenome.fitness = 0;
		alterations = false;
		pmut = Toto.PMUT;
		nmut = Toto.NMUT;
	}

	protected int eval(Genes g) {
		int e, f,
			bons,			// numero resultados bons
			total,			// total resultados possiveis
			count=0;		// Resultados cumpridos - fitness

		for (e=0; e<Toto.nEquipas; e++) {
			bons = total = 0;
			for (f=0; f<Toto.nEquipas; f++)
				if (Toto.t[e][f] != Toto.NJOGADO && Toto.t[e][f] != Toto.NULO) {
					total++;
					if (Toto.t[e][f] == Toto.VENCE &&
						(g.gene[e] + g.gene[e+Toto.nEquipas+1] - 256
						 - g.gene[Toto.nEquipas]) > g.gene[f]) {
							count++;
							bons++;
					}
					if (Toto.t[e][f] == Toto.EMPATA &&
						(g.gene[e] + g.gene[e+Toto.nEquipas+1] - 256 
						 + g.gene[Toto.nEquipas]) >= g.gene[f] &&
						(g.gene[e] + g.gene[e+Toto.nEquipas+1] - 256 
						 - g.gene[Toto.nEquipas]) <= g.gene[f]) {
							count++;
							bons++;
					}
					if (Toto.t[e][f] == Toto.PERDE &&
						(g.gene[e] + g.gene[e+Toto.nEquipas+1] - 256 
						 + g.gene[Toto.nEquipas]) < g.gene[f]) {
							count++;
							bons++;
					}
				}
			for (f=0; f<Toto.nEquipas; f++)
				if (Toto.t[f][e] != Toto.NJOGADO && Toto.t[f][e] != Toto.NULO) {
					total++;
					if (Toto.t[f][e] == Toto.VENCE &&
						(g.gene[f] + g.gene[f+Toto.nEquipas+1] - 256
						- g.gene[Toto.nEquipas]) > g.gene[e])
							bons++;
					if (Toto.t[f][e] == Toto.EMPATA &&
						(g.gene[f] + g.gene[f+Toto.nEquipas+1] - 256 
						+ g.gene[Toto.nEquipas]) > g.gene[e] &&
						(g.gene[f] + g.gene[f+Toto.nEquipas+1] - 256 
						 - g.gene[Toto.nEquipas]) < g.gene[e])
							bons++;
					if (Toto.t[f][e] == Toto.PERDE &&
						(g.gene[f] + g.gene[f+Toto.nEquipas+1] - 256 
						+ g.gene[Toto.nEquipas]) < g.gene[e])
							bons++;
				}
			g.bom[e] = (bons >= total*PPBOM/100);
			g.bom[e+Toto.nEquipas+1] = (bons >= total*PPBOM/100);
		}
		return count;
	}
	
	public double evaluate() {
		int i;
		
		for (best=0, i=0; i<POPSIZE; i++) {
			// calcula fitness
			pop[i].fitness = (double)eval(pop[i]);
			// procura melhor genoma
			if (pop[i].fitness > pop[best].fitness)
				best = i;
		}
		// Guarda o melhor genoma de sempre
		if (pop[best].fitness >= bestgenome.fitness) {
			bestgenome = pop[best];
			alterations = true;
		}
		estatisticas();
		return bestgenome.fitness;
	}

	protected void estatisticas() {
		int i;
		double minx, maxx, medx;
		
		minx = maxx = medx = pop[0].fitness;
		for (i=1; i<POPSIZE; i++) {
			if (pop[i].fitness < minx) minx = pop[i].fitness;
			if (pop[i].fitness > maxx) maxx = pop[i].fitness;
			medx += pop[i].fitness;
		}
		min = minx;
		max = maxx;
		med = medx/POPSIZE;
	}

	public void select(int metod) {
		int		i, j;
		double	total = 0;
		
		switch (metod) {
			case NOLINEAR3:
				for (i=0; i<POPSIZE; i++) {
					pop[i].pfitness = 1.0 / (5.0*(1.0-
						(pop[i].fitness-min+1)/
						(max-min+1))+1.0) - 1.0/6.0;
					total += pop[i].pfitness;
				}
				break;
			case NOLINEAR:
			case WINDOW:
			case NORMAL:
			default:
				break;
		}
		tfitness = total;
		/* fitness relativo para cada genoma */
		for (i=0; i<POPSIZE; i++)
			pop[i].rfitness = pop[i].pfitness / tfitness;
		
		/* fitness acumulado para cada genoma */
		pop[0].cfitness = pop[0].rfitness;
		for (i=1; i<POPSIZE; i++)
			pop[i].cfitness = pop[i-1].cfitness + pop[i].rfitness;
		
		/* selecciona usando o fitness acumulado */
		/* s os melhores sobrevivem */
		/* certificar que o melhor sobrevive - elitismo */
		popaux[0] = pop[best];
		for (i=1; i<POPSIZE; i++) {
			for (j=0; j<POPSIZE-1; j++)		// -1, para prevenir os arredondamentos
				if (pop[j].cfitness >= Math.random()) break;
			popaux[i] = pop[j];
		}
		for (i=0; i<POPSIZE; i++)
				pop[i] = new Genes(popaux[i]);
/*		pop = popaux;  */
		/* comeando todos por cruzar */
/**/	for (i=0; i<POPSIZE; i++)
			pop[i].cruzou = false;

	}
	
	/* Crossover multiponto com mscara e propagao dos bons */
	protected void cross(Genes g1, Genes g2) {
		int  g, h, gfim;
		long genaux;
		int  splitmask = (int)(Genes.nGenes / LLONG);
		int  splitleft = Genes.nGenes % LLONG;
		long mask = (long)(1+Math.random()*(Math.pow(2, splitleft)-2));

		gfim = splitleft;
		for (h=0; h<splitmask+1; h++) {
			for (g=0; g<gfim; g++) {
				if ( (mask & 1) == 1 )			// mscara a 1
					if (!g1.bom[g] && !g2.bom[g]) {
						genaux = g1.gene[g];
						g1.gene[g] = g2.gene[g];
						g2.gene[g] = genaux;
					}
					else
						if ( g1.bom[g] && !g2.bom[g])
							g2.gene[g] = g1.gene[g];
						else
							if (!g1.bom[g] &&  g2.bom[g])
								g1.gene[g] = g2.gene[g];
				mask >>= 1;
			}
			gfim = LLONG;
			mask = (long)(1+Math.random()*(Math.pow(2, LLONG)-2));
		}
		g1.cruzou = true;
		g2.cruzou = true;
	}
	
	public void crossover() {
		int i, k, aux;
		
		for (k=0; k<POPSIZE/2; k++) {
			// encontra o primeiro
			for (i=0; i<POPSIZE; i++)
				if (!pop[i].cruzou)
					break;
			// encontra o segundo
			aux = (int)(Math.random() * POPSIZE) % POPSIZE;
			while (pop[aux].cruzou || (aux==i))
				aux = ++aux % POPSIZE;
			cross(pop[i], pop[aux]);
		}
	}
	
	/* Mutao com mscara, s altera genes bons maus */
	public int mutate() {
		int count, i, j, igene;
		long mask;
		
		for (count=0, i=0; i<POPSIZE; i++)
			if (Math.random() <= pmut)
				for (j=(int)(Math.random()*nmut+1); j>0; j--) {
					do
						igene = (int)(Math.random()*Genes.nGenes) % Genes.nGenes;
					while (pop[i].bom[igene]);
					mask = (long)(Math.random()*Math.pow(2, Genes.NBITSGENE));
					pop[i].gene[igene] ^= mask;
					count++;
				}
		return count;
	}
}
