/* Resoluo do Totobola utilizando Algortmos Genticos
 *
 * Realizado no mbito do TFC, 1999/00, DEEC, IST, UNL, por
 *  Paulo Jorge Silva, n 26518
 */
import java.awt.*;
import java.io.*;
import java.awt.event.*;

public class Toto {
	final static int NEQUIPAS = 18,		// N equipas por defeito
			 NEQUIMIN = 4,		// N mnimo de equipas
			 NEQUIMAX = 20,		// N mximo de equipas
			 MAXGENS = 10000,	// Mx geraes
			 NMUT = 1;			// N mut max por cromossoma
	final static double  PMUT = 0.1;	// Probabilidade de mutao
	final static char VENCE = '3',		// Equipa vence
			  EMPATA = '1',		// Equipa empata
			  PERDE = '0',		// Equipa perde
			  NJOGADO = '-',	// No jogado
			  NULO = '8';		// Contra ele prprio
	Populacao	p;					// Populao de cromossomas
	static String	[]nome = new String[NEQUIMAX];
	static char	[][]t = new char[NEQUIMAX][NEQUIMAX]; // Equipa q joga em casa guarda resultados
	static int	[][]jogos = new int[NEQUIMAX][NEQUIMAX]; // Jornadas
	static int	[][]jogo = new int[NEQUIMAX/2][2];   // Prxima jornada
	boolean		packFrame = false;	//????
	static int	nEquipas = NEQUIPAS,	// n equipas
                            jorjogo = 0,	// jornada dos jogos currente
				jorresu = 0;	// jornada dos resultados currente
	static Thread	proc;
	static String	dirLiga = ".\\",			// directoria p defeito
			fileLiga = "liga.txt";		// ficheiro p defeito
	static Janela	j = new Janela();	// Janela da aplicao
	static double	optimoFitness;		// Fitness a atingir
	static Toto	toto;

	public Toto() {

		if (packFrame)
			j.pack();
		else
			j.validate();
		j.setVisible(true);
	}

	public void showEquipas() {
		long	[][]geneAux = new long[NEQUIMAX][2];
		long	buff;
		int		e, i;
		boolean alter = true;

		// ordenar as equipas
		for (e=0; e<nEquipas; e++) {
			geneAux[e][0] = p.bestgenome.gene[e] + p.bestgenome.gene[e+nEquipas+1];
			geneAux[e][1] = e;
		}
		while (alter) {
			alter = false;
			for (e=0; e<nEquipas-1; e++)
				if (geneAux[e+1][0] > geneAux[e][0]) {
					alter = true;
					for (i=0; i<2; i++) {
						buff = geneAux[e][i];
						geneAux[e][i] = geneAux[e+1][i];
						geneAux[e+1][i] = buff;
					}
				}
		}
		for (e=0; e<nEquipas; e++) {
			j.mostraEquipa(nome[(int)geneAux[e][1]], 4*e);
			j.mostraEquipa(String.valueOf(p.bestgenome.gene[(int)geneAux[e][1]]), 4*e+1);
			j.mostraEquipa(String.valueOf(
				p.bestgenome.gene[(int)geneAux[e][1]+nEquipas+1]-256), 4*e+2);
			j.mostraEquipa(String.valueOf(p.bestgenome.bom[(int)geneAux[e][1]]), 4*e+3);
		}
	}

	public void showJogos() {
		int e;

		for(e=0; e<nEquipas/2; e++) {
//			j.mostraResult(nome[jogo[e][0]], 3*e+24);
//			j.mostraResult(" - " + nome[jogo[e][1]], 3*e+25);
			if (p.bestgenome.gene[jogo[e][0]]
				+ p.bestgenome.gene[jogo[e][0]+nEquipas+1] - 256
				- p.bestgenome.gene[jogo[e][1]] >
				p.bestgenome.gene[nEquipas])
					j.mostraResult("1", 3*e+26);
			if (p.bestgenome.gene[jogo[e][0]]
				+ p.bestgenome.gene[jogo[e][0]+nEquipas+1] - 256
				- p.bestgenome.gene[jogo[e][1]] <=
				p.bestgenome.gene[nEquipas] &&
				p.bestgenome.gene[jogo[e][1]] -
				(p.bestgenome.gene[jogo[e][0]]
				+ p.bestgenome.gene[jogo[e][0]+nEquipas+1] - 256)
				<= p.bestgenome.gene[nEquipas])
					j.mostraResult("X", 3*e+26);
			if (p.bestgenome.gene[jogo[e][1]] -
				(p.bestgenome.gene[jogo[e][0]]
				+ p.bestgenome.gene[jogo[e][0]+nEquipas+1] - 256)
				> p.bestgenome.gene[nEquipas])
					j.mostraResult("2", 3*e+26);
		}
	}

	public boolean bomFicheiro(FileInputStream in) throws IOException {
		String	logo = "";
		int		c, n;

		for (n=0; n<11; n++) {
			if ((c=in.read()) == -1)
				break;
			logo += (char)c;
		}
		in.close();
		return logo.equalsIgnoreCase("Totobola...");
	}

	public double leFicheiro(FileInputStream in) throws IOException {
		double	optimoFitness=0;
		int		c, e, f, count = 0;
		String	jornadaIdx = new String();

		for (e=0; e<11; e++) {
			in.read();
		}
		nEquipas = in.read();
		in.read();
		in.read();
		for (e=0; e<nEquipas; e++) {
			nome[e] = "";
			while ((c=in.read()) != 13)
				if (c != 10)
					nome[e] += (char)c;
/***/			System.out.println(nome[e]);
		}
		for (e=0; e<nEquipas; e++)
			for (f=0; f<nEquipas; f++) {
				do
					c = in.read();
				while (c==(int)' ' || c==13 || c==10);
				t[e][f] = (char)c;
				if (c != Toto.NJOGADO && c != Toto.NULO)
					optimoFitness++;
			}
		j.mostraResult(String.valueOf(optimoFitness), 5);
		in.read();
		in.read();
		for (e=0; e<nEquipas; e++)
			for (f=0; f<nEquipas; f++) {
				jornadaIdx = "";
				while ((c=in.read()) != 13)
					if (c != 10 && c != (int)' ')
						jornadaIdx += (char)c;
				jogos[e][f] = Integer.valueOf(jornadaIdx).intValue();
			}
		in.read();
		Toto.jorjogo = in.read();
		Toto.jorresu = in.read();
		in.close();
		for (e=0; e<nEquipas; e++)
			for (f=0; f<nEquipas; f++)
				if (Toto.jogos[e][f] == jorresu+1) {
					jogo[count][0] = e;
					jogo[count][1] = f;
					count++;
				}
		return optimoFitness;
	}

	public static void main(String[] args) throws IOException, InterruptedException {
		File			fin;
		FileInputStream in;
		int				e;
		double			bestEverFitness;
		int				nmut=0;
		long			n, f;

		System.out.println("Totobola...");
		proc = Thread.currentThread();
		toto = new Toto();

		// incio do ciclo infinito
		for (f=0; true; f++) {
			while (!ListenerLiga.executa)
				proc.sleep(250);

			fin = new File(Toto.dirLiga + Toto.fileLiga);
			if (fin.exists()) {
				in = new FileInputStream(fin);
				if (Toto.toto.bomFicheiro(in)) {
					in = new FileInputStream(fin);
					Toto.optimoFitness = Toto.toto.leFicheiro(in);
					Toto.j.setTitle("Totobola... " + Toto.dirLiga + Toto.fileLiga);

					for(e=0; e<Toto.nEquipas/2; e++) {
						Toto.j.mostraResult(Toto.nome[Toto.jogo[e][0]], 3*e+24);
						Toto.j.mostraResult(" - " + Toto.nome[Toto.jogo[e][1]], 3*e+25);
					}

					// incio do algortmo gentico
					Toto.toto.p = new Populacao(Toto.nEquipas*2+1); //(n genes)
					bestEverFitness = 0;
					for (n=0; n<Toto.MAXGENS; n++) {
						Toto.j.mostraResult(String.valueOf(n+1), 1);
						Toto.toto.p.evaluate();
						Toto.toto.p.select(Populacao.NOLINEAR3);
						Toto.toto.p.crossover();
						nmut = Toto.toto.p.mutate();
						if (Toto.toto.p.alterations) {
							if (Toto.toto.p.bestgenome.fitness > bestEverFitness)
								bestEverFitness = Toto.toto.p.bestgenome.fitness;
							Toto.toto.showEquipas();
							Toto.j.mostraResult(String.valueOf(bestEverFitness), 4);
							Toto.j.mostraResult(String.valueOf((int)(bestEverFitness/optimoFitness*100)), 7);
							Toto.j.mostraResult(String.valueOf(Toto.toto.p.bestgenome.gene[Toto.nEquipas]), 10);
							Toto.toto.showJogos();
							Toto.toto.p.alterations = false;
							if (!ListenerLiga.executa)
								break;
						}
						if (n==0)
							proc.sleep(1000);
					}
				ListenerLiga.executa = false;
				}
			}
		}
	}
}
